Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/metrics.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/metrics.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/metrics.cpp	(revision 2090)
@@ -13,16 +13,4 @@
 using namespace	VMI;
 
-GLuint VMI::computeBackgroundArea(Mesh *mesh, GLuint *histogram) {
-    GLuint i, area = 0;
-
-    for (i=0; i<mesh->numTriangles; i++) { // Triangles start at 1
-        if (mesh->triangles[i].enable == TRUE) {
-            area += histogram[i + 1];
-        }
-    }
-
-    return ((GLuint)(width * height) - area);
-}
-
 GLdouble VMI::computeMeanProjAreaNoBG(GLuint **histogram, GLuint numCameras, int t) {
     GLuint i;
@@ -37,15 +25,16 @@
 
 GLdouble VMI::computeMeanProjArea(GLuint **histogram, GLuint numCameras, int t) {
-    GLuint i;
-    GLdouble mean_proj_area = 0.0, total_proj_area, resolution = width * height;
-
-    for (i=0; i<numCameras; i++) {
+	GLuint i;
+	GLdouble mean_proj_area = 0.0, total_proj_area, resolution = width * height;
+
+	for (i=0; i<numCameras; i++) {
 		total_proj_area = resolution - histogram[i][0];
 
-        mean_proj_area += histogram[i][t] / total_proj_area;
-    }
-
-    return (mean_proj_area / (GLdouble)numCameras);
-}
+		mean_proj_area += histogram[i][t] / total_proj_area;
+	}
+
+	return (mean_proj_area / (GLdouble)numCameras);
+}
+///////////////////////////////////////////////////////////////////////////////
 // Mutual Information
 GLdouble VMI::computeMI(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint cam) {
@@ -76,4 +65,78 @@
     return (I / numCameras);
 }
+
+GLdouble VMI::decMI(GLdouble I, GLuint **histogram, GLuint numCameras, GLuint cam, Change *c) {
+    GLdouble newI = I * numCameras, 
+             pov = 0.0, po;
+    GLsizei total_proj_area = width * height;
+    GLint i, t;
+
+    // decrease entropy of deleted triangles
+    for (i=0; i<c->numDel; i++) { 
+        
+        t = c->deleted[i].id;
+        // projected pixels of triangle t is at t + 1 position
+        pov = (GLdouble)histogram[cam][t + 1] / total_proj_area;
+        
+        po = computeMeanProjAreaNoBG(histogram, numCameras, t + 1) / total_proj_area;
+        
+        if ((pov > 0.0) && (po > 0.0))
+            newI -= (pov * log2(pov / po));
+    }
+
+    // decrease entropy of modified triangles
+    for (i=0; i<c->numMod; i++) { 
+        
+        t = c->modified[i].id;
+        // projected pixels of triangle t is at t + 1 position
+        pov = (GLdouble)histogram[cam][t + 1] / total_proj_area;
+        
+        po = computeMeanProjAreaNoBG(histogram, numCameras, t + 1) / total_proj_area;
+        
+        if ((pov > 0.0) && (po > 0.0))
+            newI -= (pov * log2(pov / po));
+    }
+
+    // take into account the background
+    pov = (GLdouble)histogram[cam][0] / total_proj_area;
+    
+    po = computeMeanProjAreaNoBG(histogram, numCameras, 0) / total_proj_area;
+    
+    if ((pov > 0.0) && (po > 0.0))
+        newI -= (pov * log2(pov / po));
+
+    return (newI / numCameras);
+}
+
+GLdouble VMI::incMI(GLdouble I, GLuint **histogram, GLuint numCameras, GLuint cam, Change *c) {
+    GLdouble newI = I * numCameras, 
+             pov = 0.0, po;
+    GLsizei total_proj_area = width * height;
+    GLuint i, t;
+
+    // increase entropy of modified triangles
+    for (i=0; i<(GLuint)c->numMod; i++) { 
+        
+        t = c->modified[i].id;
+        // projected pixels of triangle t is at t + 1 position
+        pov = (GLdouble)histogram[cam][t + 1] / total_proj_area;
+        
+        po = computeMeanProjAreaNoBG(histogram, numCameras, t + 1) / total_proj_area;
+        
+        if ((pov > 0.0) && (po > 0.0))
+            newI += (pov * log2(pov / po));
+    }
+
+    // take into account the background
+    pov = (GLdouble)histogram[cam][0] / total_proj_area;
+    
+    po = computeMeanProjAreaNoBG(histogram, numCameras, 0) / total_proj_area;
+    
+    if ((pov > 0.0) && (po > 0.0))
+        newI += (pov * log2(pov / po));
+
+    return (newI / numCameras);
+}
+///////////////////////////////////////////////////////////////////////////////
 // Kullback-Leibler divergence
 GLdouble VMI::computeKL(Mesh *mesh, GLuint *histogram) {
@@ -107,5 +170,5 @@
 // Hellinger divergence (square root)
 GLdouble VMI::computeHE(Mesh *mesh, GLuint *histogram) {
-    GLdouble I = 0.0, t, 
+    GLdouble I = 0.0, temp, 
              total_real_area = 0.0, pi, qi;
     GLsizei  total_proj_area = (width * height) - histogram[0];
@@ -128,12 +191,13 @@
             if ((pi > 0.0) && (qi > 0.0)) {
                 
-                t = sqrt(pi) - sqrt(qi);
+                temp = sqrt(pi) - sqrt(qi);
                 
-                I += (t * t);
+                I += (temp * temp);
             }
         }
     }
 
-    return (sqrt(I / 2.0));
+    return sqrt(I / 2.0);
+
 }
 
@@ -168,17 +232,32 @@
 ///////////////////////////////////////////////////////////////////////////////
 GLdouble VMI::computeEntropy(GLuint **histogram, GLuint numCameras, GLuint k) {
-    GLdouble H = 0.0, POk, pi,
-		     total_proj_area, resolution = width * height, pv = 1.0 / (GLdouble)numCameras;
+	GLdouble H = 0.0, POk, pi,
+					 total_proj_area, resolution = width * height, pv = 1.0 / (GLdouble)numCameras;
+	GLuint i;
+
+	for (i=0; i<numCameras; i++) {
+
+		total_proj_area = resolution - histogram[i][0];
+
+		POk = computeMeanProjArea(histogram, numCameras, k + 1);
+
+		if (POk > 0.0)
+			pi = (pv * ((double)histogram[i][k + 1]) / total_proj_area ) / POk;
+		else pi = 0.0;
+
+		if (pi > 0.0)
+			H += (pi * log2(pi));
+	}
+
+	return -H;
+}
+
+GLdouble VMI::computeMixedEntropy(GLdouble *mixed, GLuint numCameras) {
+    GLdouble H = 0.0, pi;
     GLuint i;
     
     for (i=0; i<numCameras; i++) {
-
-		total_proj_area = resolution - histogram[i][0];
-        
-        POk = computeMeanProjArea(histogram, numCameras, k + 1);
-        
-        if (POk > 0.0)
-            pi = (pv * ((double)histogram[i][k + 1]) / total_proj_area ) / POk;
-        else pi = 0.0;
+        
+        pi = mixed[i];
         
         if (pi > 0.0)
@@ -188,61 +267,46 @@
     return -H;
 }
-
-GLdouble VMI::computeMixedEntropy(GLdouble *mixed, GLuint numCameras) {
-    GLdouble H = 0.0, pi;
-    GLuint i;
-    
-    for (i=0; i<numCameras; i++) {
-        
-        pi = mixed[i];
-        
-        if (pi > 0.0)
-            H += (pi * log2(pi));
-    }
-    
-    return -H;
-}
 ///////////////////////////////////////////////////////////////////////////////
 // Jensen-Shannon divergence
 GLdouble VMI::computeJS(GLuint **histogram, GLuint numCameras, GLuint j, GLuint k) {
-    GLdouble js, Wj = 0.0, Wk = 0.0, POj, POk, pj, pk, total_proj_area,
-		     resolution = width * height, pv = 1.0 / (GLdouble)numCameras,
-			 *mixing = (GLdouble *)malloc(numCameras * sizeof(GLdouble));
-    GLuint i;
-    
-    POj = computeMeanProjArea(histogram, numCameras, j + 1);
-    POk = computeMeanProjArea(histogram, numCameras, k + 1);
-
-    //printf("%f %f\n", POj, POk);
-    
-    // weights
-    if ((POj + POk) > 0.0) {
-        Wj = POj / (POj + POk);
-        Wk = POk / (POj + POk);
-    }
-
-    //printf("%f %f\n", Wj, Wk);
-    
-    // Compute mixing distribution
-    for (i=0; i<numCameras; i++) {
-        
+	GLdouble js, Wj = 0.0, Wk = 0.0, POj, POk, pj, pk, total_proj_area,
+					 resolution = width * height, pv = 1.0 / (GLdouble)numCameras,
+					 *mixing = (GLdouble *)malloc(numCameras * sizeof(GLdouble));
+	GLuint i;
+
+	POj = computeMeanProjArea(histogram, numCameras, j + 1);
+	POk = computeMeanProjArea(histogram, numCameras, k + 1);
+
+	//printf("%f %f\n", POj, POk);
+
+	// weights
+	if ((POj + POk) > 0.0) {
+		Wj = POj / (POj + POk);
+		Wk = POk / (POj + POk);
+	}
+
+	//printf("%f %f\n", Wj, Wk);
+
+	// Compute mixing distribution
+	for (i=0; i<numCameras; i++) {
+
 		total_proj_area = resolution - histogram[i][0];
 
-        if (POj > 0.0) pj = (pv * ((double)histogram[i][j + 1] / total_proj_area)) / POj;
-        else pj = 0.0;
-            
-        if (POk > 0.0) pk = (pv * ((double)histogram[i][k + 1] / total_proj_area)) / POk;
-        else pk = 0.0;
-            
-        mixing[i] = (Wj * pj) + (Wk * pk);
-    }
-    
-    js = /*(POj + POk) * */(computeMixedEntropy(mixing, numCameras) 
-		- (Wj * computeEntropy(histogram, numCameras, j)) 
-		- (Wk * computeEntropy(histogram, numCameras, k)));
+		if (POj > 0.0) pj = (pv * ((double)histogram[i][j + 1] / total_proj_area)) / POj;
+		else pj = 0.0;
+
+		if (POk > 0.0) pk = (pv * ((double)histogram[i][k + 1] / total_proj_area)) / POk;
+		else pk = 0.0;
+
+		mixing[i] = (Wj * pj) + (Wk * pk);
+	}
+
+	js = /*(POj + POk) * */(computeMixedEntropy(mixing, numCameras) 
+			- (Wj * computeEntropy(histogram, numCameras, j)) 
+			- (Wk * computeEntropy(histogram, numCameras, k)));
 
 	free(mixing);
 
-    return js;
+	return js;
 }
 ///////////////////////////////////////////////////////////////////////////////
@@ -250,4 +314,9 @@
 
     renderScene(histogram, numCameras);
+}
+
+void VMI::getProjectedAreasWin(GLuint **histogram, GLuint numCameras, Change *c) {
+
+    renderSceneWin(histogram, numCameras, c);
 }
 
@@ -301,5 +370,5 @@
     meanI /= numCameras;
 #endif
-    printIs(mis, numCameras);
+    //printIs(mis, numCameras);
     printf("I0= %f\n", meanI); 
 }
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/saliency.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/saliency.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/saliency.cpp	(revision 2090)
@@ -23,30 +23,41 @@
 
 void VMI::computeSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras) {
-    GLuint i = 0;
-    double sal;
-    
-    maxSal = minSal = computeTriangleSaliency(mesh, histogram, numCameras, 0);
-
-    mesh->triangles[0].saliency = maxSal;
-
-    for (i=1; i<mesh->numTriangles; i++) {
-
-        sal = computeTriangleSaliency(mesh, histogram, numCameras, i);
-
-        if (sal > maxSal) maxSal = sal;
-        if (sal < minSal) minSal = sal;
-        
-        mesh->triangles[i].saliency = sal;
-    }
-
-    printf("\nMax Sal: %f  Min Sal: %f\n", maxSal, minSal);
-
-    percentile = computePercentile(alpha, mesh->triangles, mesh->numTriangles);
-    printf("\n%dth percentile: %f\n", alpha, percentile);
+	GLuint i = 0;
+	double sal;
+
+	maxSal = minSal = computeTriangleSaliency(mesh, histogram, numCameras, 0);
+
+	mesh->triangles[0].saliency = maxSal;
+
+	for (i=1; i<mesh->numTriangles; i++) {
+
+		sal = computeTriangleSaliency(mesh, histogram, numCameras, i);
+
+		if (sal > maxSal) maxSal = sal;
+		if (sal < minSal) minSal = sal;
+
+		mesh->triangles[i].saliency = sal;
+	}
+
+	printf("\nMax Sal: %f  Min Sal: %f\n", maxSal, minSal);
+
+	percentile = computePercentile(alpha, mesh->triangles, mesh->numTriangles);
+	printf("\n%dth percentile: %f\n", alpha, percentile);
+}
+
+void updateTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, int v) {
+	int i, t;
+
+	for(i=0; i<(int)mesh->vertices[v].numTriangles; i++) {
+
+		t = mesh->vertices[v].triangles[i];
+
+		mesh->triangles[t].saliency = computeTriangleSaliency(mesh, histogram, numCameras, t);
+	}
 }
 
 double VMI::computeTriangleSaliency(Mesh *mesh, GLuint **histogram, GLuint numCameras, GLuint k) {
-    GLuint i, l, v0, v1, v2;
-    int triangles[MAX_NUM_TRI], n = 0;
+     GLuint i, l, v0, v1, v2;
+    int *triangles = NULL, n = 0;
     double sal = 0.0;
     
@@ -55,4 +66,9 @@
     v2 = mesh->triangles[k].indices[2];
     
+    /* Allocating memory */
+    triangles = (int *)malloc((mesh->vertices[v0].numTriangles +
+                               mesh->vertices[v1].numTriangles +
+                               mesh->vertices[v2].numTriangles) * sizeof(int));
+
     for(i=0; i<mesh->vertices[v0].numTriangles; i++) {
         l = mesh->vertices[v0].triangles[i];
@@ -86,4 +102,6 @@
     //getchar();
     
+    free(triangles);
+
     return (sal /*/ n*/);
 }
@@ -150,5 +168,6 @@
     if((fp= fopen(filename, "rt"))== NULL) {
         printf("Can't open file %s\n", filename);
-        exit(1);
+				getchar();
+				exit(1);
     }
 
@@ -219,35 +238,37 @@
 void VMI::computeRGB(double min, double max,double value,float *r,float *g,float *b)
 {
-    //Dados el valor máximo, el mínimo y el valor que le quieres calcular el color te devuelve el respectivo RGB.
-    if(value>max) value=max;
-    if(value<min) value=min;
-    
-    if(max==min) value=1;
-    else value=(float)(value-min)/(float)(max-min);
-    
-    if (value<=0.25)
-    {
-        (*r)=0;
-        (*g)=4*value;
-        (*b)=1;
-    }
-    else if (value<=0.50)
-    {
-        (*r)=0;
-        (*g)=1;
-        (*b)=2-4*value;
-    }
-    else if (value<=0.75)
-    {
-        (*r)=4*value-2;
-        (*g)=1;
-        (*b)=0;
-    }
-    else
-    {
-        (*r)=1;
-        (*g)=4-4*value;
-        (*b)=0;
-    }
+	/* Given the maximum, the minimum value and the demanded color value returns
+	 * the respective RGB color
+	 */
+	if(value>max) value=max;
+	if(value<min) value=min;
+
+	if(max==min) value=1;
+	else value=(float)(value-min)/(float)(max-min);
+
+	if (value<=0.25)
+	{
+		(*r)=0;
+		(*g)=4*value;
+		(*b)=1;
+	}
+	else if (value<=0.50)
+	{
+		(*r)=0;
+		(*g)=1;
+		(*b)=2-4*value;
+	}
+	else if (value<=0.75)
+	{
+		(*r)=4*value-2;
+		(*g)=1;
+		(*b)=0;
+	}
+	else
+	{
+		(*r)=1;
+		(*g)=4-4*value;
+		(*b)=0;
+	}
 }
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/color.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/color.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/color.cpp	(revision 2090)
@@ -7,8 +7,10 @@
 using namespace VMI;
 
-Color *VMI::initColors(GLuint numTriangles) {
+Color *VMI::initColors(GLuint numColors) {
     Color *colors;
 
-    colors = (Color *)malloc(sizeof(Color) * (numTriangles + 1)); // Triangles start at 1
+    colors = (Color *)malloc(sizeof(Color) * (numColors + 1));
+		/* The 0 position is reserved for the BACKGROUND, thus color of triangle 0
+       is at 1 position and so on */
 
     if (colors == NULL) {
@@ -17,14 +19,14 @@
     }
 
-    // Fill the color buffer with BACKGROUND
-    memset(colors, BACKGROUND, sizeof(Color) * (numTriangles + 1));
+    /* Fill the color buffer with the BACKGROUND color */
+    memset(colors, BACKGROUND, sizeof(Color) * (numColors + 1));
 
     return colors;
 }
 
-void VMI::fillAllColors(Color *colors, GLuint numTriangles, GLuint begin, GLuint end, GLubyte color) {
+void VMI::fillAllColors(Color *colors, GLuint numColors, GLuint begin, GLuint end, GLubyte color) {
     GLuint i;
 
-    if (end > numTriangles) return;
+    if (end > numColors) return;
 
     for (i=begin; i<end; i++) {
@@ -84,11 +86,11 @@
 }
 
-void VMI::setColors2(Color *colors, GLuint numTriangles, GLuint begin, GLuint end) {
+void VMI::setColors2(Color *colors, GLuint numColors, GLuint begin, GLuint end) {
     GLuint i, 
         channel = 0,
-        step = (numTriangles < MAX_NUM_COLORS) ? (MAX_NUM_COLORS / numTriangles) : 1;
+        step = (numColors < MAX_NUM_COLORS) ? (MAX_NUM_COLORS / numColors) : 1;
     GLubyte r = 1;
 
-    if (end > numTriangles) return;
+    if (end > numColors) return;
 
     for (i = begin; i < end; i++) {
@@ -126,13 +128,13 @@
             channel = 0;
         }
-        //printf("c:%d (%d,%d,%d,%d)\n",i, colors[i].r, colors[i].g, colors[i].b,  colors[i].a);
+        //printf("c:%d (%d,%d,%d,%d)\n", i, colors[i].r, colors[i].g, colors[i].b,  colors[i].a);
         //getchar();
     }
 }
 
-void VMI::setColors3(Color *colors, GLuint numTriangles, GLubyte color) {
+void VMI::setColors3(Color *colors, GLuint numColors, GLubyte color) {
     GLuint i;
     
-    for (i = 0; i < numTriangles; i++) {
+    for (i = 0; i < numColors; i++) {
 
         colors[i].r = color;
@@ -141,13 +143,13 @@
         colors[i].a = 0;
 
-        //printf("c:%d (%d,%d,%d,%d)\n",i, colors[i].r, colors[i].g, colors[i].b,  colors[i].a);
+        //printf("c:%d (%d,%d,%d,%d)\n", i, colors[i].r, colors[i].g, colors[i].b,  colors[i].a);
         //getchar();
     }
 }
 
-void VMI::setColors4(Color *colors, GLuint numTriangles) {
+void VMI::setColors4(Color *colors, GLuint numColors) {
     GLuint i, c = 1;
     
-    for (i = 0; i < numTriangles; i++) {
+    for (i = 0; i < numColors; i++) {
 
         colors[i].r = c & 0xFF;
@@ -156,5 +158,5 @@
         colors[i].a = (c & 0xFF000000) >> 24;
 
-        //printf("c:%d (%d,%d,%d,%d)\n",i, colors[i].r, colors[i].g, colors[i].b,  colors[i].a);
+        //printf("c:%d (%d,%d,%d,%d)\n", i, colors[i].r, colors[i].g, colors[i].b,  colors[i].a);
         c++; 
     }
@@ -162,9 +164,9 @@
 }
 
-void VMI::viewColors(Color *colors, GLuint numTriangles) {
+void VMI::viewColors(Color *colors, GLuint numColors) {
     GLuint i;
 
     printf("\n");
-    for (i=0; i<numTriangles; i++) 
-        printf("c:%d (%d,%d,%d,%d)\n",i, colors[i].r, colors[i].g, colors[i].b,  colors[i].a);
+    for (i=0; i<numColors; i++) 
+        printf("c:%d (%d,%d,%d,%d)\n", i, colors[i].r, colors[i].g, colors[i].b,  colors[i].a);
 }
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/bheap.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/bheap.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/bheap.cpp	(revision 2090)
@@ -154,4 +154,22 @@
         }
     }
+}
+/* bh_mark() marks an item from the binary heap pointed to by h.
+ */
+void bh_mark(bheap_t *h, int item, int flag)
+{
+    h->a[h->p[item]].dirty = flag;
+}
+/* bh_get_key() returns the key value of an item from the binary heap h.
+ */
+double bh_get_key(bheap_t *h, int item)
+{
+    return h->a[h->p[item]].key;
+}
+/* bh_is_dirty() returns the dirty value of an item from the binary heap h.
+ */
+int bh_is_dirty(bheap_t *h, int item)
+{
+    return h->a[h->p[item]].dirty;
 }
 
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/glm.c
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/glm.c	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/glm.c	(revision 2090)
@@ -135,5 +135,5 @@
     copied = 1;
     for (i = 1; i <= *numvectors; i++) {
-        for (j = 1; j <= copied; j++) {
+        for (j = 1; j </*=*/ copied; j++) {
             if (glmEqual(&vectors[3 * i], &copies[3 * j], epsilon)) {
                 goto duplicate;
@@ -1723,9 +1723,9 @@
     vectors  = model->vertices;
     copies = glmWeldVectors(vectors, &numvectors, epsilon);
-    
-#if 0
+
+//#if 0
     printf("glmWeld(): %d redundant vertices.\n", 
-        model->numvertices - numvectors - 1);
-#endif
+        model->numvertices - numvectors /* - 1*/);
+//#endif
     
     for (i = 0; i < model->numtriangles; i++) {
Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/main.cpp	(revision 983)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/libs/vmi/src/main.cpp	(revision 2090)
@@ -25,5 +25,6 @@
           bBeQuiet         = GL_FALSE,
           bSaveLog         = GL_FALSE,
-          bLoadCamerasFromFile = GL_FALSE;
+          bLoadCamerasFromFile = GL_FALSE,
+          bRemoveRedundantVertices = GL_TRUE;
 
 GLuint cameraType = 0,
@@ -55,6 +56,6 @@
     gluPerspective(fov, (GLdouble)width / height, 0.1, 40.0);
     
-    glPixelStorei(GL_PACK_ALIGNMENT, 1);
-    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
+    //glPixelStorei(GL_PACK_ALIGNMENT, 1);
+    //glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
     
     glShadeModel(GL_FLAT);
@@ -62,8 +63,7 @@
     glDisable(GL_BLEND);
 
-    //glEnable(GL_CULL_FACE); // important
+    glEnable(GL_CULL_FACE); // important
 
     glEnable(GL_DEPTH_TEST);
-    glDepthFunc(GL_LEQUAL);
 
     if (GL_TRUE != glewIsSupported((const char*) "GL_EXT_framebuffer_object"))
@@ -117,4 +117,11 @@
     {
         fprintf(stderr,"GL_ARB_vertex_buffer_object extension is not available!\n");
+    } else {
+#ifdef VERTEX_BUFFER_OBJECTS
+        
+        glGenBuffersARB(1, &vertex_buf);
+        
+        glGenBuffersARB(1, &color_buf);
+#endif
     }
     if (GL_TRUE != glewIsSupported((const char*) "GL_ARB_occlusion_query"))
@@ -238,22 +245,15 @@
     glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
 
-    // Switch to projection mode
-    glMatrixMode(GL_PROJECTION);
-    // Save previous matrix which contains the 
-    // settings for the perspective projection
-    glPushMatrix();
-    // Reset matrix
-    glLoadIdentity();
-    glOrtho(0.0, (GLdouble)width, 0.0, (GLdouble)height, 1.0, 1.0);
-    glMatrixMode(GL_MODELVIEW);
-    glLoadIdentity();
+    setOrthographicProjection();
 
     glEnable(GL_TEXTURE_2D);
     glBindTexture(GL_TEXTURE_2D, color_tex);
     glBegin(GL_QUADS);
-    glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, 0.0);
-    glTexCoord2f(0.0, 1.0); glVertex3f(-1.0, 1.0, 0.0);
-    glTexCoord2f(1.0, 1.0); glVertex3f( 1.0, 1.0, 0.0);
-    glTexCoord2f(1.0, 0.0); glVertex3f( 1.0, -1.0, 0.0);
+    
+    glTexCoord2f(0.0f, 0.0f); glVertex2f(0.0f, 0.0f);
+    glTexCoord2f(1.0f, 0.0f); glVertex2f(width, 0.0f); 
+    glTexCoord2f(1.0f, 1.0f); glVertex2f(width, height);
+    glTexCoord2f(0.0f, 1.0f); glVertex2f(0.0f, height);
+
     glEnd();
     glFlush();
@@ -312,4 +312,81 @@
     ///////////////////////////////////////////////////////////////////////////
 }
+void VMI::renderSceneWin(GLuint **histogram, GLuint numCameras, Change *c)
+{
+    GLuint i, j, t, background;
+    int del_area, mod_area;
+    GLfloat min[3], max[3];
+
+    // draw to the frame buffer
+    glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, fb);
+
+    //printChange(c);
+    getBoundingBox(c, min, max);
+    //printf("\n(%f,%f,%f)-(%f,%f,%f)\n", min[0], min[1], min[2], max[0], max[1], max[2]);
+    
+    // Apply HW acceleration OpenGL Technique
+    applyHWAcceleration(); 
+
+    glDrawBuffer(GL_BACK);
+    glReadBuffer(GL_BACK);
+
+    // Get the projected areas for all cameras
+    for (i=0; i<numCameras; i++) {
+        
+        // Clear color and depth buffers
+        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
+        
+        glMatrixMode(GL_MODELVIEW);
+        glLoadIdentity();
+        
+        // Camera  i
+        gluLookAt(cameras[i].eyeX, cameras[i].eyeY, cameras[i].eyeZ,
+                  cameras[i].centerX, cameras[i].centerY, cameras[i].centerZ,
+                  cameras[i].upX, cameras[i].upY, cameras[i].upZ);
+        
+        renderGeometry();
+        glFlush();
+        
+        ///////////////////////////////////////////////////////////////////////////
+        background = histogram[i][0];
+        //printf("b: %d\n", histogram[i][0]);
+
+        del_area = 0;
+        mod_area = 0;
+
+        for (j=0; j<( GLuint)c->numDel; j++) {
+            t = c->deleted[j].id;
+            del_area += histogram[i][t + 1];
+
+            histogram[i][t + 1] = 0;
+        }
+
+        for (j=0; j<( GLuint)c->numMod; j++) {
+            t = c->modified[j].id;
+            del_area += histogram[i][t + 1];
+
+            histogram[i][t + 1] = 0;
+        }
+        
+        getSWHistogramWin(histogram[i], pixels, min, max, c); 
+
+        for (j=0; j<( GLuint)c->numMod; j++) {
+            t = c->modified[j].id;
+            mod_area += histogram[i][t + 1];
+
+            //printf("t%d: %d\n",t, histogram[i][t + 1]);
+        }
+        histogram[i][0] = background + (del_area - mod_area);
+        //printf("b: %d\n", histogram[i][0]);
+    }
+    //getchar();
+
+    // draw to the window, reading from the color texture
+    glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, 0);
+
+    if (!bEnableOffScreen) drawTexture();
+    
+    ///////////////////////////////////////////////////////////////////////////
+}
 
 void VMI::freeMemory(void) {
@@ -339,5 +416,32 @@
 #endif
 
-		glutDestroyWindow(vmiWin);
+		if (vmiWin != 0)
+		{
+			glutDestroyWindow(vmiWin);
+		}
+
+#ifdef VERTEX_BUFFER_OBJECTS
+    glDeleteBuffersARB(1, &vertex_buf);
+    
+    glDeleteBuffersARB(1, &color_buf);
+#endif
+
+	pmodel = NULL; // The .obj model
+
+	pixels = NULL;
+
+	cameras = NULL;
+	numCameras = 0;
+
+	colors = NULL;
+
+	histogram = NULL;
+  queries = NULL;
+
+	mesh = NULL;
+
+	initialIs = NULL;
+
+	vmiWin = 0;
 }
 
@@ -391,29 +495,7 @@
 
 #ifdef SALIENCY
-#ifdef KL // Kullback-Leibler
-	sprintf(s,"%s_%d_%d_VKL_S.obj", filename, numCameras, mesh->currentNumTriangles);
-#endif
-#ifdef MI // Mutual Information
-	sprintf(s,"%s_%d_%d_VMI_S.obj", filename, numCameras, mesh->currentNumTriangles);
-#endif
-#ifdef HE // Hellinger
-	sprintf(s,"%s_%d_%d_VHE_S.obj", filename, numCameras, mesh->currentNumTriangles);
-#endif
-#ifdef CS // Chi-Square
-	sprintf(s,"%s_%d_%d_VCS_S.obj", filename, numCameras, mesh->currentNumTriangles);
-#endif
+    sprintf(s,"%s_%d_%d_%s_S.obj", filename, numCameras, mesh->currentNumTriangles, EXT);
 #else
-#ifdef KL // Kullback-Leibler
-	sprintf(s,"%s_%d_%d_VKL.obj", filename, numCameras, mesh->currentNumTriangles);
-#endif
-#ifdef MI // Mutual Information
-	sprintf(s,"%s_%d_%d_VMI.obj", filename, numCameras, mesh->currentNumTriangles);
-#endif
-#ifdef HE // Hellinger
-	sprintf(s,"%s_%d_%d_VHE.obj", filename, numCameras, mesh->currentNumTriangles);
-#endif
-#ifdef CS // Chi-Square
-	sprintf(s,"%s_%d_%d_VCS.obj", filename, numCameras, mesh->currentNumTriangles);
-#endif
+    sprintf(s,"%s_%d_%d_%s.obj", filename, numCameras, mesh->currentNumTriangles, EXT);
 #endif
 
@@ -454,95 +536,73 @@
  *  RGBA display mode, and handle input events.
  */
-//int main(int argc, char** argv)
-//{
-//    char s[MAX_CHAR];
-//
-//    process_cmdline(argc, argv);
-//    
-//    // Load a .obj model
-//    pmodel = glmReadOBJ(argv[argc-1]);
-//    if (!pmodel) exit(0);
-//    glmUnitize(pmodel);
-//    //glmFacetNormals(pmodel);
-//    //glmVertexNormals(pmodel, 90.0);
-//
-//    mesh = initMesh(pmodel);
-//    //printMesh(mesh);
-//    //getchar();
-//
-//    if ((numDemandedTriangles == 0) || (numDemandedTriangles >= mesh->currentNumTriangles))
-//        usage_error("Illegal number of triangles.");
-//
-//    printf("w: %d h: %d\n", width, height);
-//    printf("t: %d c: %d o: %d r: %f\n", numDemandedTriangles, cameraType, bEnableOffScreen, radius);
-//    //getchar();
-//
-//    // Get a filename without extension
-//    strncpy(filename, argv[argc - 1], strlen(argv[argc - 1]) - 4);
-//    
-//    glutInit(&argc, argv);
-//    glutInitDisplayMode(GLUT_DEPTH | GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA); /* RGB and Alpha */
-//    glutInitWindowSize(width, height);
-//    glutInitWindowPosition(100, 100);
-//
-//#ifdef KL // Kullback-Leibler
-//    sprintf(s, "VKL - [%s]", argv[argc-1]); 
-//#endif
-//#ifdef MI // Mutual Information
-//    sprintf(s, "VMI - [%s]", argv[argc-1]); 
-//#endif
-//#ifdef HE // Hellinger
-//    sprintf(s, "VHE - [%s]", argv[argc-1]); 
-//#endif
-//#ifdef CS // Chi-Square
-//    sprintf(s, "VCS - [%s]", argv[argc-1]); 
-//#endif
-//    
-//    vmiWin = glutCreateWindow(s);
-//
-//    glewInit();
-//
-//    init();
-//
-//    if (bLoadCamerasFromFile == GL_FALSE) {
-//        switch (cameraType) {
-//        case 0:
-//            cameras = setCameras(radius, OCTAHEDRON, &numCameras);
-//            printf("Number of cameras: %d\n", OCTAHEDRON);
-//            break;
-//        case 1:
-//            cameras = setCameras(radius, ICOSAHEDRON, &numCameras);
-//            printf("Number of cameras: %d\n", ICOSAHEDRON);
-//            break;
-//        case 2:
-//            cameras = setCameras(radius, DODECAHEDRON, &numCameras);
-//            printf("Number of cameras: %d\n", DODECAHEDRON);
-//            break;
-//        default:
-//            break;
-//        }
-//    } else {
-//        sprintf(s,"%s.cam", filename);
-//        
-//        cameras = loadCameras(radius, s, &numCameras);
-//        //getchar();
-//    }
-//
-//		histogram = initHistogram(mesh->currentNumTriangles, numCameras);
-//
-//    initialIs = initIs(numCameras);
-//    
-//		if (!bEnableOffScreen) {
-//			  glutReshapeFunc(reshape);
-//        glutKeyboardFunc(keyboard);
-//			  glutDisplayFunc(display);
-//		}
-//		else {
-//        display();
-//    		freeMemory(); 		
-//    }
-//    exit(0);
-//
-//    glutMainLoop();
-//    return 0;
-//}
+/*int main(int argc, char** argv)
+{
+    char s[MAX_CHAR];
+
+    process_cmdline(argc, argv);
+    
+    // Load a .obj model
+    pmodel = glmReadOBJ(argv[argc-1]);
+    if (!pmodel) exit(0);
+    glmUnitize(pmodel);
+    if (bRemoveRedundantVertices == GL_TRUE)
+        glmWeld(pmodel, 0.00001);
+    //glmFacetNormals(pmodel);
+    //glmVertexNormals(pmodel, 90.0);
+
+    mesh = initMesh(pmodel);
+    //printMesh(mesh);
+    //getchar();
+
+    if ((numDemandedTriangles == 0) || (numDemandedTriangles >= mesh->numTriangles))
+        usage_error("Illegal number of triangles.");
+
+    printf("w: %d h: %d\n", width, height);
+    printf("t: %d c: %d o: %d r: %f\n", numDemandedTriangles, cameraType, bEnableOffScreen, radius);
+    //getchar();
+
+    // Get a filename without extension
+    strncpy(filename, argv[argc - 1], strlen(argv[argc - 1]) - 4);
+    
+    glutInit(&argc, argv);
+    glutInitDisplayMode(GLUT_DEPTH | GLUT_RGBA | GLUT_DOUBLE | GLUT_ALPHA); // RGB and Alpha
+    glutInitWindowSize(width, height);
+    glutInitWindowPosition(100, 100);
+
+    sprintf(s, "%sW - [%s]", EXT, argv[argc-1]);
+    
+    glutCreateWindow(s);
+
+    glewInit();
+
+    init();
+
+    if (bLoadCamerasFromFile == GL_FALSE)
+        cameras = setCameras(radius, cameraType, &numCameras);
+    else {
+        sprintf(s,"%s.cam", filename);
+        
+        cameras = loadCameras(radius, s, &numCameras);
+        //getchar();
+    }
+
+    histogram = initHistogram(mesh->numTriangles, numCameras);
+
+    initialIs = initIs(numCameras);
+    
+    // Allocate memory for colors
+    colors = initColors(mesh->numTriangles);
+
+    // Set a different color for every triangle 
+    setColors4(colors, mesh->numTriangles);
+
+    if (!bEnableOffScreen){
+        glutReshapeFunc(reshape);
+        glutKeyboardFunc(keyboard);
+        glutDisplayFunc(display);
+
+        glutMainLoop();
+    } else display();
+
+    return 0;
+}*/
